
#ifndef INSTANCE_H
#define INSTANCE_H

#include "rtexec.h"
#include "tinoo.h"
#include "tinio.h"
#include "tinthrsem.h"


#define MAX_INPUTS  100
#define MAX_OUTPUTS 100
#define MAX_THREADS 100
#define MAX_SEMAPHORES 100

void connect(TIN *tin);

bool isfunction(const char *name);
void getfunction(const char *function, char *name, int *nparams,char paramlist[][MAX_PARAMS]);

class InstanceFinder
{
private:
    Input *inputs[MAX_INPUTS];
    int ninputs;
    Output *outputs[MAX_OUTPUTS];
    int noutputs;
    TINThreadWithSemaphores *threads[MAX_THREADS];
    int nthreads;
    char *sem_names[MAX_SEMAPHORES];
	int sem_pos[MAX_SEMAPHORES];
    int nsemaphores;
public:
	InstanceFinder() { ninputs=0; noutputs=0; nthreads=0; nsemaphores=0; }
    Input *getInput(const char *name);
    Output *getOutput(const char *name);
    TINThreadWithSemaphores *getThread(const char *name);
    void add(Input *new_in);
    void add(Output *new_out);
    void add(TINThreadWithSemaphores *new_thread);
    void addSemaphore(const char *new_sem_name, int pos);
};

extern RTexec executor;
extern InstanceFinder Devs;

#endif INSTANCE_H