/*
 * Project.......: CROSSROAD CONTROL SIMULATOR
 * File..........: cross_contr_custom.cpp
 * Author........: Rogai Davide
 * Last review date: 16/05/2002
 * Description:
 *		Base generated by TILCONF... edited to link the controller to
 *		the traffic light environment
 */

#include "cross_contr.h"

#include "traffic_req.h"
#include "traffic_light.h"
#include "traffic_panel.h"

//Evaluation of a custom Input device created to handle button request
io_val ReqInput::eval()
{
	if(!req)
		return(IO_NONE);
	if(req->getState())
		return(IO_TRUE);
	return(IO_FALSE);
}

//Action of a custom Ouput device created to control a light
void LightOutput::action(bool val)
{
	light1->switchLight(val);
	light2->switchLight(val);
}

//Running code of a custom Thread created to scroll a text on a panel
bool PanelThread::toRun() 
{ 	
	int lenght, cursor;

	strcpy(scrolled,scrolltext);
	strcat(scrolled,scrolltext);
	lenght=strlen(scrolltext);
	cursor=0;
	while(true)
	{
		panel1->setText(scrolled+cursor);
		panel2->setText(scrolled+cursor);
		cursor=(cursor+1)%lenght;
		sleep(200);
	}
	return(true); 
}

void PanelThread::setScrollText(const char *text)
{
	strncpy(scrolltext,text,100);
	scrolltext[100-1]='\0';
}
