/*
 * Project.......: CROSSROAD CONTROL SIMULATOR
 * File..........: traffic_light.h
 * Author........: Rogai Davide
 * Last review date: 16/05/2002
 * Description:
 *		Interface of the traffic light element
 */

#if !defined(AFX_TRAFFIC_LIGHT_H__6294BA85_8569_4A76_A463_F65D61C36312__INCLUDED_)
#define AFX_TRAFFIC_LIGHT_H__6294BA85_8569_4A76_A463_F65D61C36312__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>

#define LIGHT_BORDER 2
#define LIGHT_SIZE 15

#define GREEN_COLOR 0x0000FF00
#define YELLOW_COLOR 0x00007FFF
#define RED_COLOR 0x000000FF

#define DEFAULT_OFF_COLOR 0x008F8F8F

void setTrafficHDC(HDC trafficHdc);

class Light
{
private:
	int x, y;
	int on_color,off_color;

	//state of the light
	bool switch_state;
public:
	Light(int light_color) { on_color=light_color; off_color=DEFAULT_OFF_COLOR; }
	void setPos(int posx, int posy) {x=posx;y=posy;};
	void switchLight(bool val);
	void draw();
};

class TrafficLight  
{
private:
	Light green, yellow, red;
	
	//direction of the road the look at the traffic light
	int x,y;
	int dir;
public:
	TrafficLight(int x, int y, int trafficdir=0);
	void draw();
	
	//retrieving the lights to link them to the control system
	Light *linkGreen() { return &green; }
	Light *linkYellow(){ return &yellow; }
	Light *linkRed() { return &red; }
};

#endif // !defined(AFX_TRAFFIC_LIGHT_H__6294BA85_8569_4A76_A463_F65D61C36312__INCLUDED_)
